import java.awt.*;
import javax.swing.*;
import java.io.*;

class Billiards extends Rule
{
  public Billiards(JFrame mainFrame, SquareCell squareCell)
  {
    super(mainFrame, squareCell);
    this.mainFrame = mainFrame;
    this.squareCell = squareCell;
  }

  public void setNewRule()
  {
  }

  public void setOptions()
  {
  }

  public void setDefault()
  {
  }

  public void changeRule()
  {
  }

  public void writeRule(PrintWriter pw)
  {
    pw.println("#Rule = Billiards");
  }

  public void readRule(BufferedReader br)
  {
  }

  public int step(int row, int column)
  {
    int nw = squareCell.getNeighbor(row - 1, column - 1);
    int w  = squareCell.getNeighbor(row    , column - 1);
    int sw = squareCell.getNeighbor(row + 1, column - 1);
    int n  = squareCell.getNeighbor(row - 1, column    );
    int s  = squareCell.getNeighbor(row + 1, column    );
    int ne = squareCell.getNeighbor(row - 1, column + 1);
    int e  = squareCell.getNeighbor(row    , column + 1);
    int se = squareCell.getNeighbor(row + 1, column + 1);
    int cell = squareCell.getNeighbor(row, column);
    if (cell == 5)
      return 5;
    if (cell == 0)
    {
      if ((s == 1) && (e == 3))
        return 4;
      if ((w == 1) && (n == 3))
        return 2;
      if ((w == 2) && (s == 4))
        return 1;
      if ((n == 2) && (e == 4))
        return 3;
      if ((sw == 1) && (se != 4))
        return 1;
      if (nw == 2)
        return 2;
      if (ne == 3)
        return 3;
      if (se == 4)
        return 4;
      if ((s == 1) && (e == 5))
        return 4;
      if ((w == 1) && (n == 5))
        return 2;
      if ((e == 3) && (s == 5))
        return 4;
      if ((n == 3) && (w == 5))
        return 2;
      if ((w == 2) && (s == 5))
        return 1;
      if ((n == 2) && (e == 5))
        return 3;
      if ((s == 4) && (w == 5))
        return 1;
      if ((e == 4) && (n == 5))
        return 3;
    }
    if ((cell == 1) && (n == 5) && (e == 5))
      return 3;      
    if ((cell == 2) && (s == 5) && (e == 5))
      return 4;
    if ((cell == 3) && (s == 5) && (w == 5))
      return 1;
    if ((cell == 4) && (n == 5) && (w == 5))
      return 2;
    if ((cell == 1) && (ne == 5) && ((n == 2) || (e == 4)))
      return 3;
    if ((cell == 2) && (se == 5) && ((s == 1) || (e == 3)))
      return 4;
    if ((cell == 3) && (sw == 5) && ((s == 4) || (w == 2)))
      return 1;
    if ((cell == 4) && (nw == 5) && ((n == 3) || (w == 1)))
      return 2;  
    return 0;
  }

  public int getNoStates()
  {
    return 6;
  }
}
