public class CaRunner implements Runnable
{
  private SquareCell1D squareCell1D;
  
  public CaRunner(SquareCell1D squareCell1D)
  {
    this.squareCell1D = squareCell1D;
  }

  public void run()
  {
    try
    {
      while (squareCell1D.isRunning())
      { 
        squareCell1D.step();
        squareCell1D.drawDisplay();
        int delay = squareCell1D.getDelay();
        if (delay > 0)
          Thread.sleep(delay);
      }
    }
    catch (InterruptedException e)
    {
    }
  }
}
