import java.awt.*;
import javax.swing.*;
import java.io.*;

class Life extends Rule
{
  public Life(JFrame mainFrame, SquareCell squareCell)
  {
    super(mainFrame, squareCell);
    this.mainFrame = mainFrame;
    this.squareCell = squareCell;
  }

  public void setNewRule()
  {
  }

  public void setOptions()
  {
  }

  public void setDefault()
  {
  }

  public void changeRule()
  {
  }

  public void writeRule(PrintWriter pw)
  {
  }

  public void readRule(BufferedReader br)
  {
  }

  public int step(int row, int column)
  {
    int neighborCount =
      squareCell.getNeighbor(row - 1, column - 1) +
      squareCell.getNeighbor(row    , column - 1) +
      squareCell.getNeighbor(row + 1, column - 1) +
      squareCell.getNeighbor(row - 1, column    ) +
      squareCell.getNeighbor(row + 1, column    ) +
      squareCell.getNeighbor(row - 1, column + 1) +
      squareCell.getNeighbor(row    , column + 1) +
      squareCell.getNeighbor(row + 1, column + 1);
    int cell = squareCell.getNeighbor(row, column);
    if ((neighborCount == 3) || ((cell == 1) && (neighborCount == 2)))
      return 1;
    return 0;
  }

  public int getNoStates()
  {
    return 2;
  }
}
